package com.mall.coupon.service.impl;

import com.mall.coupon.mapper.HomeSubjectMapper;
import com.mall.coupon.service.HomeSubjectService;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.mall.coupon.service.HomeSubjectService;
import com.mall.coupon.domain.dto.HomeSubjectDto;
import com.mall.coupon.domain.entity.HomeSubject;
import com.mall.coupon.domain.vo.HomeSubjectVo;
import com.mall.common.domain.vo.result.PageResult;
import com.mall.common.domain.vo.result.Result;
import com.mall.common.domain.vo.result.ResultCodeEnum;

import java.util.List;

/**
 * <p>
 * 首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】 服务实现类
 * </p>
 *
 * @author Bunny
 * @since 2025-07-06 11:15:40
 */
@Service
@Transactional
public class HomeSubjectServiceImpl extends ServiceImpl<HomeSubjectMapper, HomeSubject> implements HomeSubjectService {

    /**
     * * 首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】 服务实现类
     *
     * @param pageParams 首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】分页查询page对象
     * @param dto        首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】分页查询对象
     * @return 查询分页首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】返回对象
     */
    @Override
    public PageResult<HomeSubjectVo> getHomeSubjectPage(Page<HomeSubject> pageParams, HomeSubjectDto dto) {
        IPage<HomeSubjectVo> page = baseMapper.selectListByPage(pageParams, dto);

        return PageResult.<HomeSubjectVo>builder()
                .list(page.getRecords())
                .pageNo(page.getCurrent())
                .pageSize(page.getSize())
                .total(page.getTotal())
                .build();
    }

    /**
     * 添加首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】
     *
     * @param dto 首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】添加
     */
    @Override
    public void addHomeSubject(HomeSubjectDto dto) {
        HomeSubject homeSubject =new HomeSubject();
        BeanUtils.copyProperties(dto, homeSubject);
        save(homeSubject);
    }

    /**
     * 更新首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】
     *
     * @param dto 首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】更新
     */
    @Override
    public void updateHomeSubject(HomeSubjectDto dto) {
        HomeSubject homeSubject =new HomeSubject();
        BeanUtils.copyProperties(dto, homeSubject);
        updateById(homeSubject);
    }

    /**
     * 删除|批量删除首页专题表【jd首页下面很多专题，每个专题链接新的页面，展示专题商品信息】
     *
     * @param ids 删除id列表
     */
    @Override
    public void deleteHomeSubject(List<Long> ids) {
        removeByIds(ids);
    }
}